using System;
using System.Runtime.InteropServices;
using System.Threading;

namespace Webb.PublicCOM.TestCOM1
{
	#region Events raised by your COM class
	//
	// TODO: Insert delegates for events raised by your class here.
	//
	//public delegate void Event1Handler(int i, int j);
	public delegate void OnEventHandler(object i_sender,object i_arg);

	[	Guid("386E65D8-80B2-4D90-BAF4-F5C4EF0BC7C4"),
		InterfaceType(ComInterfaceType.InterfaceIsIDispatch) ]
	public interface IWebbTestCOM01Events
	{
		//
		// TODO: Insert event handlers for events your class raises here.
		//
		//[DispId(1)] void Event1(int i, int j);
		[DispId(1)] void OnEvent(object i_sender,object i_arg);
		[DispId(2)] void OnError(object i_sender,object i_arg);
	}
	#endregion

	#region Interface published by your COM class
	[	Guid("1781AA69-91B3-4CE8-B109-BFBB30F1DE66"),
		InterfaceType(ComInterfaceType.InterfaceIsDual) ]
	public interface IWebbTestCOM01
	{
		//
		// TODO: Insert functions your class publishes here.
		//
		//[DispId(1)] int Function1(string s1, string s2);
		[DispId(1)] string GetSystemTime();
		[DispId(2)] void Run();
		[DispId(3)] void Stop();
	}
	#endregion

	[	Guid("DA2EE075-87BE-4613-9EBF-F9D370085FDD"),
		ProgId("Webb.PublicCOM.TestCOM1.WebbTestCOM01"),
		ClassInterface(ClassInterfaceType.None),
		ComSourceInterfaces(typeof(IWebbTestCOM01Events)) ]
	public class WebbTestCOM01 : IWebbTestCOM01
	{
		private bool m_isRuning = true;
		public event OnEventHandler OnEvent;
		public event OnEventHandler OnError;
		//
		// TODO: Insert events raised by your class here.
		//
		//public event Event1Handler Event1;

		// A COM class must have a public parameterless constructor.
		// Otherwise the class might not be registered for COM and
		// cannot be created by CreateObject.
		public WebbTestCOM01() : base()
		{
		}

		//
		// TODO: Implement the methods of your class interface here.
		//
		//public int Function1(string s1, string s2)
		//{
		//	return 0;
		//}

		public string GetSystemTime()
		{
			return DateTime.Now.ToString();
		}

		public void Run()
		{
			//Thread m_runingThread = new Thread(new ThreadStart(Runing));
			//m_runingThread.Start();
			Runing();
		}

	
		public void Stop()
		{
			this.m_isRuning = false;
		}

		private void Runing()
		{
			int m_result = 100;
			Random m_rand = new Random();
			while(m_isRuning)
			{
				m_result = m_rand.Next(1000);				
				if(m_result%10==0)
				{
					if(this.OnError!=null)
					{
						this.OnError(this,m_result);
					}
				}
				else
				{
					if(this.OnEvent!=null)
					{
						this.OnEvent(this,m_result);
					}
				}
			}
		}
	}
}